<?php

/****************************************************************************************
 *                                                                                      *
 * Yii2 Parsel Query                                                                    *
 * Copyright (c) 2023 PT. IsAtDev. All Rights Reserved.                                 *
 *                                                                                      *
 * ==================================================================================== *
 *                                                                                      *
 * Company       : PT. IsAtDev Digital Innovasi                                         *
 * NIB           : 2111220046069                                                        *
 * Website       : https://www.isatdev.com                                              *
 *                                                                                      *
 * ==================================================================================== *
 *                                                                                      *
 * Author        : Mirdani Handoko                                                      *
 * Email         : dani@emailku.id                                                      *
 * File Name     : ParselQuery.php                                                      *
 * Update        : Monday, 04 December 2023 13:25:04 WIB                                *
 *                                                                                      *
 ****************************************************************************************/

namespace IsAtDev\Parsel;

use Yii;
use yii\base\BaseObject;
use yii\base\InvalidConfigException;
use yii\db\Query;

/**
 * The main class for this extension.  The main method is [[processQuery]].
 *
 * @property-read string $lastError The message when a query can't be parsed.
 * @property-read array $tokens The tokens created by [[Lexer::lex]].
 * @property-read array $queryParts The query parts created by [[Parser::parse]].
 * @property-read string $sql The sql query.
 * @property [[yii\db\Query]] $dbQuery The database query we'll be adding to
 * @property string|array $userQuery The search string entered by the user, or the array of sub-query parts
 * @property array|null $searchFields The list of fields to include in our search.  If not specified, use text/varchar/char fields in select clause.  If * then use all searchable fields in table.
 *
 * @author    John Snook
 * @date      2018-07-28
 * @license   https://github.com/johnsnook/yii2-parsel/LICENSE
 * @copyright 2018 John Snook Consulting
 */
final class ParselQuery extends BaseObject
{
    /**
     * @var string The message when a query can't be parsed.
     */
	private string $lastError;

    /**
     * @var Query  The database query we'll be adding to
     */
	private Query $dbQuery;

    /**
     * @var string|array $userQuery The search string entered by the user, or the array of sub-query parts
     */
	private string|array $userQuery;

    /**
     * @var array|null The list of fields to include in our search.  If not specified, use text/varchar/char fields in select clause.  If * then use all searchable fields in table.
     */
	private ?array $searchFields;
	
	/**
	 * Get the last error, if any
	 *
	 * @return string
	 */
	public function getLastError(): string
	{
		return $this->lastError;
	}
	
	/**
	 * Requests the tokens (lexing) then calls the parser and returns the array of
	 * query parts to process into a where clause
	 *
	 * @return array
	 */
	public function getQueryParts(): array
	{
		$parser = new Parser();
		$tokens = $this->tokens;
		$queryParts = [];
		try {
			$queryParts = $parser->parse($tokens);
		} catch (ParserException $pe) {
			/**
			 * Welp, something is borked.  Set the errormessage and bounce
			 */
			$this->lastError = $pe->getMessage();
		}
		
		return $queryParts;
	}
	
	/**
	 * The list of fields to search
	 *
	 * @return array|null
	 */
	public function getSearchFields(): ?array
	{
		return $this->searchFields;
	}
	
	/**
	 * Assign the list of fields to search
	 *
	 * @param array $val
	 */
	public function setSearchFields(array $val): void
	{
		$this->searchFields = $val;
	}
	
	/**
	 *
	 * @return string The sql string generated by ParselQuery. For debugging purposes
	 * @throws InvalidConfigException
	 */
	public function getSql(): string
	{
		return SqlFormatter::format($this->getDbQuery()->createCommand()->getRawSql());
	}
	
	/**
	 * Begins the work of lexing, parsing and processing then returns the Query
	 *
	 * @return Query
	 * @throws InvalidConfigException
	 */
	public function getDbQuery(): Query
	{
		$queryParts = $this->queryParts;
		
		return $this->processQuery($this->dbQuery, $queryParts, $this->searchFields);
	}
	
	/**
	 *
	 * @param Query $val
	 */
	public function setDbQuery(Query $val): void
	{
		$this->dbQuery = $val;
	}
	
	/**
	 * The main event.  Takes a database query, a user entered query and an
	 * optional list of fields to search and returns the query with all the
	 * where clauses and sub-queries ready for use in an \yii\data\ActiveDataProvider.
	 *
	 * @param Query      $dbQuery    The database query we'll be adding to
	 * @param array      $queryParts The array of sub-query parts
	 * @param array|null $fields     The list of fields to include in our search.  If not specified, use text/varchar/char fields in select clause.  If * then use all searchable fields in table.
	 *
	 * @return Query The transformed database query.
	 * @throws InvalidConfigException
	 */
	protected function processQuery(Query $dbQuery, array $queryParts, array $fields = null): Query
	{
        /** replace numeric keys with the value */
        foreach ($fields as $key => $item) {
            if (is_numeric($key)) {
                $fields[$item] = $item;
                unset($fields[$key]);
            }
        }

        $this->lastError = false;
        $like = self::fuzzyOperator();
        /** If things go tits up, return the unmodified original. */
        $pQuery = clone $dbQuery;
        if (is_null($fields)) {
            if (is_null($pQuery->select)) {
                $fields = self::fields($pQuery);
            } else {
                $fields = $pQuery->select;
            }
        }

        $conjunction = 'AND';
        foreach ($queryParts as $queryPart) {
            switch ($queryPart['type']) {
                /**
                 * This is the search term we're going to compare against the
                 * fields in our table, select or argument list of fields.
                 */
                case "term":
                    $where = ['or'];

                    /**
                     * allow the user to specify a single field.
                     * 1) Copy the fields array to fieldlist
                     * 5) set the fieldlist to the single field specified in term
                     */
                    $fieldlist = $fields;
                    if (isset($queryPart['field'])) {
                        if (in_array($queryPart['field'], array_keys($fields), true)) {
                            $fieldExpression = $fields[$queryPart['field']];
                            $fieldlist = [$fieldExpression];
                        }
                    }

                    $value = self::prepareTermValue($queryPart);
                    foreach ($fieldlist as $field) {
                        if ($queryPart['fullMatch'] && !$queryPart['fuzzy']) {
                            $where[] = [$field => $value]; //{$neg}
                        } else {
                            $where[] = [$like, $field, $value, false]; //{$neg}
                        }
                    }

                    /** Ties a not() around the condition(s) */
                    if ($queryPart['negated']) {
                        $where = ['not', $where];
                    }
                    if ($conjunction === 'AND') {
                        $pQuery->andWhere($where);
                    } elseif ($conjunction === 'OR') {
                        $pQuery->orWhere($where);
                    }
                    break;
                /**
                 * Get ready to recurse.  Create a new query with the same
                 * tables(s) but only returning the primary key.
                 */
                case "query":
                    $subQuery = clone $dbQuery;
                    $pk = self::primaryKey($pQuery);
                    $subQuery->select($pk);
                    $subQuery = $this->processQuery($subQuery, $queryPart['items'], $fields);
                    /** Ties a not() around the condition(s) */
                    $not = $queryPart['negated'] ? 'NOT ' : '';
                    $where = ["{$not}IN", $pk, $subQuery];
                    if ($conjunction === 'AND') {
                        $pQuery->andWhere($where);
                    } elseif ($conjunction === 'OR') {
                        $pQuery->orWhere($where);
                    }
                    break;
                /** We hold on to the AND/OR for the next term/subquery */
                case "keyword":
                    $conjunction = strtoupper($queryPart['value']);
                    break;
            }
        }
        return $pQuery;
    }

    /**
     * Set which fuzzy database operator to use.  My favorite, postgresql uses
     * ILIKE, most others just use LIKE.
     * @todo figure out what all the other databases use.  I only checked a few.
     */
	protected static function fuzzyOperator(): string
	{
		return (Yii::$app->db->getDriverName() === 'pgsql' ? 'ILIKE' : 'LIKE');
	}
	
	/**
	 * If fields are specified in the Query::select property, use those.  If not,
	 * get introspective and use the fields in this table that are string types.
	 *
	 * @param Query $dbQuery
	 *
	 * @return array The list of fields
	 * @throws InvalidConfigException
	 * @todo figure out ecumenical way to add other types, eg dates, numbers, json
	 *
	 */
	private static function fields(Query $dbQuery): array
	{
		$return = [];
		foreach ($dbQuery->tablesUsedInFrom as $alias => $tableName) {
			$fields = (is_null($dbQuery->select) ? '*' : $dbQuery->select);
			if ($meta = Yii::$app->db->schema->getTableSchema($tableName)) {
				foreach ($meta->columns as $col) {
					if ($fields === '*' || in_array($col->name, $fields)) {
						/** only add strings */
						if (in_array($col->type, ['string', 'text', 'char'])) {
							$return [] = $alias . '.' . $col->name;
						}
					}
				}
			} else {
				throw new InvalidConfigException("Table: $tableName not found.");
			}
		}
		
		return $return;
    }

    /**
     * Based on the metadata, get the term ready for a SQL statement.  Also
     * replace user tokens with db tokens
     *
     * @param array $term
     * @return string The modified value
     */
	private static function prepareTermValue(array $term): string
	{
		$term = (object)$term;

        if ($term->fuzzy) {
            $value = str_replace(['*', '?'], ['%', '_'], $term->value);
            $split = str_split($value);
            /**
             * this part is just to make sure we don't end up with double
             * wildcards at the beginning or end of our term
             */
	        if (($split[strlen($value) - 1] !== '%') && (!$term->fullMatch)) {
                $value .= '%';
	        }
	        if (($split[0] !== '%') && (!$term->fullMatch)) {
                $value = '%' . $value;
            }
        } elseif ($term->quoted === Parser::QUOTE_SINGLE) {
            /** single quote terms are literal, so escape any wildcard chars */
            $value = str_replace('%', '\%', str_replace('_', '\_', $term->value));
        } elseif ($term->fullMatch) {
            $value = $term->value;
        } else {
            $value = '%' . $term->value . '%';
        }
        return $value;
    }

    /**
     * Figure out the primary key for use in sub-queries.
     *
     * @param Query $dbQuery
     *
     * @return string
     * @throws InvalidConfigException
     */
	private static function primaryKey(Query $dbQuery): string
    {

        foreach ($dbQuery->tablesUsedInFrom as $alias => $tableName) {
	        if ($meta = Yii::$app->db->schema->getTableSchema($tableName)) {
                if ($pk = $meta->primaryKey) {
                    return "{$alias}.{$pk}";
                }
            } else {
                /** if we didn't find a primary key in the first table, complain */
                throw new InvalidConfigException("Table: $tableName not found.");
            }
        }
        $tables = implode(',', $dbQuery->tablesUsedInFrom);
        throw new InvalidConfigException("Table(s): $tables doesn't have a primary key defined, which is required for subquerys.");
    }
	
	/**
	 * Discerns the lexemes of the users query string
	 *
	 * @return array
	 */
	public function getTokens(): array
	{
		$lexer = new Lexer();
		
		return $lexer->lex($this->userQuery);
	}
	
	/**
	 * The users query string
	 *
	 * @return array|string
	 */
	public function getUserQuery(): array|string
	{
		return $this->userQuery;
	}
	
	/**
	 * The users query string
	 *
	 * @param string $val
	 */
	public function setUserQuery(string $val): void
	{
		$this->userQuery = $val;
    }

}
